# Kernel relatad RPM utils installation destination
%global rpmkerneldir %{_rpmconfigdir}/kernel

Summary: RPM macros that list arches the full kernel is built on
Name: kernel-srpm-macros
Version: 1.0
# when bumping version and resetting release, don't forget to bump version of kernel-rpm-macros as well
Release: 22%{?dist}
# Inherit licence from Fedora
License: MIT
URL: https://src.fedoraproject.org/rpms/kernel-srpm-macros
BuildArch: noarch

# Macros
Source0: macros.kernel-srpm
Source1: macros.kernel-module-package

# Dependency generator specs
Source100: kabi.attr
Source101: kmod.attr
Source102: modalias.attr
Source103: firmware.attr
Source104: provided_ksyms.attr
Source105: required_ksyms.attr

# Dependency generator scripts
Source201: kabi.prov
Source202: modalias.prov
Source203: firmware.prov
Source204: find-provides.ksyms
Source205: find-requires.ksyms

# BRPs & Misc helper scripts, used by above specs and scripts
Source300: brp-kmod-set-exec-bit
Source301: brp-kmod-restore-perms
Source302: kmodtool
Source303: rpmsort
Source304: symset-table

%description
This packages contains the rpm macro that list what arches
the full kernel is built on.
The variable to use is kernel_arches.

%package -n kernel-rpm-macros
Summary: Macros and scripts for building kernel module packages
Version: 206
Requires: system-rpm-config
# for brp-kmod-set-exec-bit
Requires: %{_bindir}/find

%description -n kernel-rpm-macros
Macros and scripts for building kernel module packages.

%prep
# Nothing to do

%build
# Nothing to do

%install
mkdir -p %{buildroot}%{_fileattrsdir}
mkdir -p %{buildroot}%{_rpmconfigdir}/macros.d
mkdir -p %{buildroot}%{rpmkerneldir}
mkdir -p %{buildroot}%{rpmkerneldir}/provides.d

install -m 0644 %{SOURCE0} %{buildroot}%{_rpmconfigdir}/macros.d/macros.kernel-srpm
install -m 0644 %{SOURCE1} %{buildroot}%{_rpmconfigdir}/macros.d/macros.kernel-module-package

install -m 0644 %{SOURCE100} %{buildroot}%{_fileattrsdir}/kabi.attr
install -m 0644 %{SOURCE101} %{buildroot}%{_fileattrsdir}/kmod.attr
install -m 0644 %{SOURCE102} %{buildroot}%{_fileattrsdir}/modalias.attr
install -m 0644 %{SOURCE103} %{buildroot}%{_fileattrsdir}/firmware.attr
install -m 0644 %{SOURCE104} %{buildroot}%{_fileattrsdir}/provided_ksyms.attr
install -m 0644 %{SOURCE105} %{buildroot}%{_fileattrsdir}/required_ksyms.attr

install -m 0755 %{SOURCE201} %{buildroot}%{rpmkerneldir}/provides.d/kabi.prov
install -m 0755 %{SOURCE202} %{buildroot}%{rpmkerneldir}/provides.d/modalias.prov
install -m 0755 %{SOURCE203} %{buildroot}%{rpmkerneldir}/provides.d/firmware.prov
install -m 0755 %{SOURCE204} %{buildroot}%{rpmkerneldir}/find-requires.ksyms
install -m 0755 %{SOURCE205} %{buildroot}%{rpmkerneldir}/find-provides.ksyms

install -m 0755 %{SOURCE300} %{buildroot}%{rpmkerneldir}/brp-kmod-restore-perms
install -m 0755 %{SOURCE301} %{buildroot}%{rpmkerneldir}/brp-kmod-set-exec-bit
install -m 0755 %{SOURCE302} %{buildroot}%{rpmkerneldir}/kmodtool
install -m 0755 %{SOURCE303} %{buildroot}%{rpmkerneldir}/rpmsort
install -m 0755 %{SOURCE304} %{buildroot}%{rpmkerneldir}/symset-table

%files
%{_rpmconfigdir}/macros.d/macros.kernel-srpm

%files -n kernel-rpm-macros
%{_rpmconfigdir}/macros.d/macros.kernel-module-package

%{_fileattrsdir}/kabi.attr
%{_fileattrsdir}/kmod.attr
%{_fileattrsdir}/modalias.attr
%{_fileattrsdir}/firmware.attr
%{_fileattrsdir}/provided_ksyms.attr
%{_fileattrsdir}/required_ksyms.attr

%{rpmkerneldir}/provides.d/kabi.prov
%{rpmkerneldir}/provides.d/firmware.prov
%{rpmkerneldir}/provides.d/modalias.prov
%{rpmkerneldir}/find-provides.ksyms
%{rpmkerneldir}/find-requires.ksyms

%{rpmkerneldir}/brp-kmod-restore-perms
%{rpmkerneldir}/brp-kmod-set-exec-bit
%{rpmkerneldir}/kmodtool
%{rpmkerneldir}/rpmsort
%{rpmkerneldir}/symset-table

%changelog
* Fri Aug 16 2024 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 1.0-22
- Rebuilt for loongarch release

* Sat May 25 2024 Huang Yang <huangyang@loongson.cn> - 1.0-21
- [Type] other
- [DESC] add loongarch64 in kernel_arches

* Fri Sep 08 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 1.0-20
- Rebuilt for OpenCloudOS Stream 23.09

* Fri Apr 28 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 1.0-19
- Rebuilt for OpenCloudOS Stream 23.05

* Fri Mar 31 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 1.0-18
- Rebuilt for OpenCloudOS Stream 23

* Wed Mar 08 2023 Xin Cheng <denisecheng@tencent.com> - 1.0-17
- Rebuild

* Tue Mar 07 2023 Xin Cheng <denisecheng@tencent.com> - 1.0-16
- Use system-rpm-config

* Mon Aug 15 2022 Kairui Song <kasong@tencent.com> - 1.0-15
- Initial release, adapted for OpenCloudOS

* Thu Jan 20 2022 Fedora Release Engineering <releng@fedoraproject.org> - 1.0-14
- Rebuilt for https://fedoraproject.org/wiki/Fedora_36_Mass_Rebuild

* Thu Nov 18 2021 Miro Hrončok <mhroncok@redhat.com> - 1.0-13
- Bump kernel-rpm-macros to 205 to provide clear upgrade path

* Thu Nov 18 2021 Miro Hrončok <mhroncok@redhat.com> - 1.0-12
- Correct conflicts to redhat-rpm-macros < 205
- Move Perl scripts back to kernel-rpm-macros to avoid Perl in the default buildroot

* Thu Nov 18 2021 Eugene Syromiatnikov <esyr@redhat.com> - 1.0-11
- Add conflicts of redhat-rpm-macros < 204 as macros.kmp, kmodtool,
  and rpmsort were moved from the latter to the former.
- Remove RHEL-specific kABI bits from find-requires.ksyms and macros.kmp.

* Thu Nov 18 2021 Eugene Syromiatnikov <esyr@redhat.com> - 1.0-10
- Add conflicts of kernel-srpm-macros with kernel-rpm-macros < 185-9
  as macros.kmp, kmodtool, and rpmsort were moved from the latter
  to the former.

* Thu Nov 18 2021 Eugene Syromiatnikov <esyr@redhat.com> - 1.0-9
- Update scripts with RHEL-specific changes.

* Thu Jul 22 2021 Fedora Release Engineering <releng@fedoraproject.org> - 1.0-6
- Rebuilt for https://fedoraproject.org/wiki/Fedora_35_Mass_Rebuild

* Thu Jun 03 2021 Michal Domonkos <mdomonko@redhat.com> - 1.0-5
- Adopt kernel-rpm-macros & kmod.attr subpackage from redhat-rpm-config

* Tue Jan 26 2021 Fedora Release Engineering <releng@fedoraproject.org> - 1.0-4
- Rebuilt for https://fedoraproject.org/wiki/Fedora_34_Mass_Rebuild

* Tue Aug 04 2020 Merlin Mathesius <mmathesi@redhat.com> - 1.0-3
- Escape percent for %%kernel_arches macro

* Tue Jul 28 2020 Fedora Release Engineering <releng@fedoraproject.org> - 1.0-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_33_Mass_Rebuild

* Tue Jul 21 2020 Troy Dawson <tdawson@redhat.com> - 1.0-1
- Initial build
